#ifndef __CURSOR_H__
#define __CURSOR_H__
#include <string>
#include <ncurses.h>
#include "position.h"

// IMPORTANT: use unique_ptr for cursor because:
//  1. Every instance of cursor will initialize a new ncurses screen
//     Hence you should only have one instance of cursor at a time
//     Otherwise IDK what'll happen
//  2. unique_ptr insures that only one copy of a pre-declared cursor can exist
class cursor final {
private:
public:
        cursor();

        ~cursor();

        int getcmd() const;

        void show() const;

        void print_char(const position &pos, const char ch) const;

        void print_str(const position &head, const std::string str) const;
};

// IMPORTANT: this will fail when terminal size changes
// checks if terminal size fits the minimum requirements
bool check_terminal_size();

#endif
